 MEMBER

 INCLUDE('pjsip.inc'),ONCE

SipClass.Init                PROCEDURE(long RS, long CS, long CI)
 code
  if SELF.IsInited=0
    SELF.Err=SIP_onRegStateCallback(RS)
    SELF.Err=SIP_onCallStateCallback(CS)
    SELF.Err=SIP_onCallIncoming(CI)
    SELF.Err=SIP_SetSipConfig(SELF.SIPConfig)
    SELF.Err=SIP_init()
    SELF.Err=SIP_Main()
    SELF.IsInited=1
  end
SipClass.Kill                PROCEDURE()
 code

  if SELF.IsInited
    if SELF.AccountID
      SELF.Err=SIP_RemoveAccounts()
    end
    SELF.Err=SIP_Shutdown()
  end

SipClass.Login               PROCEDURE(STRING Host, LONG Port, STRING Username, STRING Pass, <STRING ProxyServer>)

uri cstring(256)
reguri cstring(256)
nam cstring(256)
isdefault bool

 code
  IF SELF.AccountID
    SELF.Err=SIP_RemoveAccounts()
  END
  SELF.HostName=clip(Host)
  SELF.UserName=clip(UserName)
  SELF.Pass=clip(Pass)
  uri='sip:'&clip(Username)&'@'&clip(Host)
  reguri='sip:'&clip(Host)&':'&Port&';transport=tcp'
  nam='*'
  if ~omitted(6)
    SELF.proxy=ProxyServer
  else
    SELF.proxy=''
  end
  isdefault=0
  SELF.AccountID=SIP_registerAccount(uri,reguri,nam,SELF.Username,SELF.Pass,SELF.proxy,isdefault)

SipClass.MakeCall               PROCEDURE(STRING Num)
calluri cstring(256)
 code

   if SELF.AccountID
     calluri='sip:'&clip(num)&'@'&clip(SELF.HostName)
     SELF.Err=SIP_MakeCall(SELF.AccountID,calluri)
   end

SipClass.Answer                  PROCEDURE()
 code

  if Self.CallID<>-1
    SELF.Err=SIP_answerCall(Self.CallID,200)
  end

SipClass.Release            PROCEDURE()
 code

  if Self.CallID<>-1
    SELF.Err=SIP_ReleaseCall(Self.CallID)
    SELF.Caller=''
  end

SipClass.GetCaller     PROCEDURE(STRING uri)
 code

  s1#=instring('sip:',uri,1,1)
  if s1#
    s2#=instring('@',uri,1,s1#)
    if s2#
      SELF.Caller=uri[s1#+4 : s2#-1]
    end
  end

SipClass.GetCallState     PROCEDURE()
 code

  execute SELF.CallState
   return ''               !PJSIP_INV_STATE_CALLING
   return ' '      !PJSIP_INV_STATE_INCOMING
   return ''                !PJSIP_INV_STATE_EARLY
   return ''           !PJSIP_INV_STATE_CONNECTING
   return ''            !PJSIP_INV_STATE_CONFIRMED
   return ''                !PJSIP_INV_STATE_DISCONNECTED
  end
  return ''

SipClass.FillCodecs       PROCEDURE(*SIPCodecsQ CQ_)
 code
 free(CQ_)
 numcodecs#=SIP_getNumOfCodecs()
 loop i#=0 to numcodecs#
   SELF.Err=SIP_getCodec(i#,CQ_.NameCodec)
   add(CQ_)
 end

SipClass.GetCurrentCodec  PROCEDURE()
Codec              CSTRING(21)

 code
 if SELF.CallID<>-1
   SELF.Err=SIP_GetCurrentCodec(SELF.CallID,Codec)
 end
 return Codec